=== modified file 'mysql-test/suite/binlog/r/binlog_mysqlbinlog_row_myisam.result'
--- mysql-test/suite/binlog/r/binlog_mysqlbinlog_row_myisam.result	2013-09-14 01:09:36 +0000
+++ mysql-test/suite/binlog/r/binlog_mysqlbinlog_row_myisam.result	2014-08-29 08:19:10 +0000
@@ -3756,56 +3756,56 @@ BEGIN
 ###   @26=NULL /* type=246 meta=2560 nullable=1 is_null=1 */
 ###   @27=NULL /* type=246 meta=2560 nullable=1 is_null=1 */
 ###   @28=NULL /* type=14 meta=0 nullable=1 is_null=1 */
-###   @29=NULL /* type=12 meta=0 nullable=1 is_null=1 */
-###   @30=1000000000 /* TIMESTAMP meta=0 nullable=0 is_null=0 */
-###   @31=NULL /* TIMESTAMP meta=0 nullable=1 is_null=1 */
-###   @32=NULL /* TIMESTAMP meta=0 nullable=1 is_null=1 */
-###   @33=NULL /* TIMESTAMP meta=65025 nullable=1 is_null=1 */
-###   @34=NULL /* TIMESTAMP meta=65024 nullable=1 is_null=1 */
-###   @35=NULL /* TIMESTAMP meta=65025 nullable=1 is_null=1 */
-###   @36=NULL /* TIMESTAMP meta=65279 nullable=1 is_null=1 */
-###   @37=NULL /* TIMESTAMP meta=65027 nullable=1 is_null=1 */
-###   @38=NULL /* TIMESTAMP meta=65024 nullable=1 is_null=1 */
-###   @39=NULL /* TIMESTAMP meta=65027 nullable=1 is_null=1 */
-###   @40=NULL /* TIMESTAMP meta=57085 nullable=1 is_null=1 */
-###   @41=NULL /* TIMESTAMP meta=65026 nullable=1 is_null=1 */
-###   @42=NULL /* TIMESTAMP meta=65024 nullable=1 is_null=1 */
-###   @43=NULL /* TIMESTAMP meta=65026 nullable=1 is_null=1 */
-###   @44=NULL /* TIMESTAMP meta=61182 nullable=1 is_null=1 */
-###   @45=NULL /* TIMESTAMP meta=0 nullable=1 is_null=1 */
-###   @46=NULL /* TIMESTAMP meta=1 nullable=1 is_null=1 */
-###   @47=NULL /* TIMESTAMP meta=255 nullable=1 is_null=1 */
-###   @48=NULL /* TIMESTAMP meta=261 nullable=1 is_null=1 */
-###   @49=NULL /* TIMESTAMP meta=0 nullable=1 is_null=1 */
-###   @50=NULL /* TIMESTAMP meta=3 nullable=1 is_null=1 */
-###   @51=NULL /* TIMESTAMP meta=765 nullable=1 is_null=1 */
-###   @52=NULL /* TIMESTAMP meta=783 nullable=1 is_null=1 */
-###   @53=NULL /* TIMESTAMP meta=0 nullable=1 is_null=1 */
-###   @54=NULL /* TIMESTAMP meta=2 nullable=1 is_null=1 */
-###   @55=NULL /* TIMESTAMP meta=510 nullable=1 is_null=1 */
-###   @56=NULL /* TIMESTAMP meta=522 nullable=1 is_null=1 */
-###   @57=NULL /* TIMESTAMP meta=65025 nullable=1 is_null=1 */
-###   @58=NULL /* TIMESTAMP meta=65024 nullable=1 is_null=1 */
-###   @59=NULL /* TIMESTAMP meta=65025 nullable=1 is_null=1 */
-###   @60=NULL /* TIMESTAMP meta=65279 nullable=1 is_null=1 */
-###   @61=NULL /* TIMESTAMP meta=0 nullable=1 is_null=1 */
-###   @62=NULL /* TIMESTAMP meta=1 nullable=1 is_null=1 */
-###   @63=NULL /* TIMESTAMP meta=255 nullable=1 is_null=1 */
-###   @64=NULL /* TIMESTAMP meta=261 nullable=1 is_null=1 */
-###   @65=NULL /* TIMESTAMP meta=1 nullable=1 is_null=1 */
-###   @66=NULL /* TIMESTAMP meta=1 nullable=1 is_null=1 */
-###   @67=NULL /* TIMESTAMP meta=1 nullable=1 is_null=1 */
-###   @68=NULL /* TIMESTAMP meta=2 nullable=1 is_null=1 */
-###   @69=NULL /* TIMESTAMP meta=2 nullable=1 is_null=1 */
-###   @70=NULL /* TIMESTAMP meta=2 nullable=1 is_null=1 */
-###   @71=NULL /* TIMESTAMP meta=3 nullable=1 is_null=1 */
-###   @72=NULL /* TIMESTAMP meta=3 nullable=1 is_null=1 */
-###   @73=NULL /* TIMESTAMP meta=3 nullable=1 is_null=1 */
-###   @74=NULL /* TIMESTAMP meta=4 nullable=1 is_null=1 */
-###   @75=NULL /* TIMESTAMP meta=4 nullable=1 is_null=1 */
-###   @76=NULL /* TIMESTAMP meta=4 nullable=1 is_null=1 */
-###   @77=NULL /* TIMESTAMP meta=63233 nullable=1 is_null=1 */
-###   @78=NULL /* TIMESTAMP meta=63489 nullable=1 is_null=1 */
+###   @29=NULL /* type=18 meta=0 nullable=1 is_null=1 */
+###   @30=1000000000 /* TIMESTAMP(0) meta=0 nullable=0 is_null=0 */
+###   @31=NULL /* TIMESTAMP(0) meta=0 nullable=1 is_null=1 */
+###   @32=NULL /* TIMESTAMP(0) meta=0 nullable=1 is_null=1 */
+###   @33=NULL /* TIMESTAMP(0) meta=65025 nullable=1 is_null=1 */
+###   @34=NULL /* TIMESTAMP(0) meta=65024 nullable=1 is_null=1 */
+###   @35=NULL /* TIMESTAMP(0) meta=65025 nullable=1 is_null=1 */
+###   @36=NULL /* TIMESTAMP(0) meta=65279 nullable=1 is_null=1 */
+###   @37=NULL /* TIMESTAMP(0) meta=65027 nullable=1 is_null=1 */
+###   @38=NULL /* TIMESTAMP(0) meta=65024 nullable=1 is_null=1 */
+###   @39=NULL /* TIMESTAMP(0) meta=65027 nullable=1 is_null=1 */
+###   @40=NULL /* TIMESTAMP(0) meta=57085 nullable=1 is_null=1 */
+###   @41=NULL /* TIMESTAMP(0) meta=65026 nullable=1 is_null=1 */
+###   @42=NULL /* TIMESTAMP(0) meta=65024 nullable=1 is_null=1 */
+###   @43=NULL /* TIMESTAMP(0) meta=65026 nullable=1 is_null=1 */
+###   @44=NULL /* TIMESTAMP(0) meta=61182 nullable=1 is_null=1 */
+###   @45=NULL /* TIMESTAMP(0) meta=0 nullable=1 is_null=1 */
+###   @46=NULL /* TIMESTAMP(0) meta=1 nullable=1 is_null=1 */
+###   @47=NULL /* TIMESTAMP(0) meta=255 nullable=1 is_null=1 */
+###   @48=NULL /* TIMESTAMP(0) meta=261 nullable=1 is_null=1 */
+###   @49=NULL /* TIMESTAMP(0) meta=0 nullable=1 is_null=1 */
+###   @50=NULL /* TIMESTAMP(0) meta=3 nullable=1 is_null=1 */
+###   @51=NULL /* TIMESTAMP(0) meta=765 nullable=1 is_null=1 */
+###   @52=NULL /* TIMESTAMP(0) meta=783 nullable=1 is_null=1 */
+###   @53=NULL /* TIMESTAMP(0) meta=0 nullable=1 is_null=1 */
+###   @54=NULL /* TIMESTAMP(0) meta=2 nullable=1 is_null=1 */
+###   @55=NULL /* TIMESTAMP(0) meta=510 nullable=1 is_null=1 */
+###   @56=NULL /* TIMESTAMP(0) meta=522 nullable=1 is_null=1 */
+###   @57=NULL /* TIMESTAMP(0) meta=65025 nullable=1 is_null=1 */
+###   @58=NULL /* TIMESTAMP(0) meta=65024 nullable=1 is_null=1 */
+###   @59=NULL /* TIMESTAMP(0) meta=65025 nullable=1 is_null=1 */
+###   @60=NULL /* TIMESTAMP(0) meta=65279 nullable=1 is_null=1 */
+###   @61=NULL /* TIMESTAMP(0) meta=0 nullable=1 is_null=1 */
+###   @62=NULL /* TIMESTAMP(0) meta=1 nullable=1 is_null=1 */
+###   @63=NULL /* TIMESTAMP(0) meta=255 nullable=1 is_null=1 */
+###   @64=NULL /* TIMESTAMP(0) meta=261 nullable=1 is_null=1 */
+###   @65=NULL /* TIMESTAMP(0) meta=1 nullable=1 is_null=1 */
+###   @66=NULL /* TIMESTAMP(0) meta=1 nullable=1 is_null=1 */
+###   @67=NULL /* TIMESTAMP(0) meta=1 nullable=1 is_null=1 */
+###   @68=NULL /* TIMESTAMP(0) meta=2 nullable=1 is_null=1 */
+###   @69=NULL /* TIMESTAMP(0) meta=2 nullable=1 is_null=1 */
+###   @70=NULL /* TIMESTAMP(0) meta=2 nullable=1 is_null=1 */
+###   @71=NULL /* TIMESTAMP(0) meta=3 nullable=1 is_null=1 */
+###   @72=NULL /* TIMESTAMP(0) meta=3 nullable=1 is_null=1 */
+###   @73=NULL /* TIMESTAMP(0) meta=3 nullable=1 is_null=1 */
+###   @74=NULL /* TIMESTAMP(0) meta=4 nullable=1 is_null=1 */
+###   @75=NULL /* TIMESTAMP(0) meta=4 nullable=1 is_null=1 */
+###   @76=NULL /* TIMESTAMP(0) meta=4 nullable=1 is_null=1 */
+###   @77=NULL /* TIMESTAMP(0) meta=63233 nullable=1 is_null=1 */
+###   @78=NULL /* TIMESTAMP(0) meta=63489 nullable=1 is_null=1 */
 ###   @79=4 /* INT meta=0 nullable=1 is_null=0 */
 # at #
 #010909  4:46:40 server id 1  end_log_pos # 	Query	thread_id=#	exec_time=#	error_code=0

=== modified file 'mysql-test/suite/innodb/r/data_types.result'
--- mysql-test/suite/innodb/r/data_types.result	2013-11-13 21:58:19 +0000
+++ mysql-test/suite/innodb/r/data_types.result	2014-08-29 05:46:28 +0000
@@ -112,7 +112,7 @@ t1_BLOB	DATA_BLOB
 t1_CHAR_100	DATA_CHAR	
 t1_CHAR_100_BINARY	DATA_MYSQL	
 t1_DATE	DATA_INT	
-t1_DATETIME	DATA_INT	
+t1_DATETIME	DATA_FIXBINARY	
 t1_DATETIME_6	DATA_FIXBINARY	
 t1_DECIMAL_10_3	DATA_FIXBINARY	
 t1_DECIMAL_10_3_UNSIGNED	DATA_FIXBINARY	UNSIGNED
@@ -137,8 +137,8 @@ t1_SET_BINARY	DATA_INT	UNSIGNED
 t1_SMALLINT	DATA_INT	
 t1_SMALLINT_UNSIGNED	DATA_INT	UNSIGNED
 t1_TEXT	DATA_BLOB	
-t1_TIME	DATA_INT	
-t1_TIMESTAMP	DATA_INT	UNSIGNED
+t1_TIME	DATA_FIXBINARY	
+t1_TIMESTAMP	DATA_FIXBINARY	UNSIGNED
 t1_TIMESTAMP_5	DATA_FIXBINARY	UNSIGNED
 t1_TIME_4	DATA_FIXBINARY	
 t1_TINYBLOB	DATA_BLOB	

=== added file 'mysql-test/suite/rpl/r/rpl_temporal_format_default_to_default.result'
--- mysql-test/suite/rpl/r/rpl_temporal_format_default_to_default.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/r/rpl_temporal_format_default_to_default.result	2014-08-29 09:22:43 +0000
@@ -0,0 +1,83 @@
+include/master-slave.inc
+[connection master]
+SELECT @@global.mysql56_temporal_format AS on_master;
+on_master
+1
+SELECT @@global.mysql56_temporal_format AS on_slave;
+on_slave
+1
+CREATE TABLE t1
+(
+c0 TIME(0),
+c1 TIME(1),
+c2 TIME(2),
+c3 TIME(3),
+c4 TIME(4),
+c5 TIME(5),
+c6 TIME(6)
+);
+CREATE TABLE t2
+(
+c0 TIMESTAMP(0),
+c1 TIMESTAMP(1),
+c2 TIMESTAMP(2),
+c3 TIMESTAMP(3),
+c4 TIMESTAMP(4),
+c5 TIMESTAMP(5),
+c6 TIMESTAMP(6)
+);
+CREATE TABLE t3
+(
+c0 DATETIME(0),
+c1 DATETIME(1),
+c2 DATETIME(2),
+c3 DATETIME(3),
+c4 DATETIME(4),
+c5 DATETIME(5),
+c6 DATETIME(6)
+);
+INSERT INTO t1 VALUES ('01:01:01','01:01:01.1','01:01:01.11','01:01:01.111','01:01:01.1111','01:01:01.11111','01:01:01.111111');
+INSERT INTO t2 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+INSERT INTO t3 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+t1	1	34	34
+t2	1	41	41
+t3	1	48	48
+SELECT * FROM t1;;
+c0	01:01:01
+c1	01:01:01.1
+c2	01:01:01.11
+c3	01:01:01.111
+c4	01:01:01.1111
+c5	01:01:01.11111
+c6	01:01:01.111111
+SELECT * FROM t2;;
+c0	2001-01-01 01:01:01
+c1	2001-01-01 01:01:01.1
+c2	2001-01-01 01:01:01.11
+c3	2001-01-01 01:01:01.111
+c4	2001-01-01 01:01:01.1111
+c5	2001-01-01 01:01:01.11111
+c6	2001-01-01 01:01:01.111111
+SELECT * FROM t3;;
+c0	2001-01-01 01:01:01
+c1	2001-01-01 01:01:01.1
+c2	2001-01-01 01:01:01.11
+c3	2001-01-01 01:01:01.111
+c4	2001-01-01 01:01:01.1111
+c5	2001-01-01 01:01:01.11111
+c6	2001-01-01 01:01:01.111111
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+t1	1	34	34
+t2	1	41	41
+t3	1	48	48
+DROP TABLE t1;
+DROP TABLE t2;
+DROP TABLE t3;
+SET @@global.mysql56_temporal_format=DEFAULT;
+SET @@global.mysql56_temporal_format=DEFAULT;
+include/rpl_end.inc

=== added file 'mysql-test/suite/rpl/r/rpl_temporal_format_mariadb53_to_mariadb53.result'
--- mysql-test/suite/rpl/r/rpl_temporal_format_mariadb53_to_mariadb53.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/r/rpl_temporal_format_mariadb53_to_mariadb53.result	2014-08-29 09:26:22 +0000
@@ -0,0 +1,85 @@
+include/master-slave.inc
+[connection master]
+SET @@global.mysql56_temporal_format=false;;
+SET @@global.mysql56_temporal_format=false;;
+SELECT @@global.mysql56_temporal_format AS on_master;
+on_master
+0
+SELECT @@global.mysql56_temporal_format AS on_slave;
+on_slave
+0
+CREATE TABLE t1
+(
+c0 TIME(0),
+c1 TIME(1),
+c2 TIME(2),
+c3 TIME(3),
+c4 TIME(4),
+c5 TIME(5),
+c6 TIME(6)
+);
+CREATE TABLE t2
+(
+c0 TIMESTAMP(0),
+c1 TIMESTAMP(1),
+c2 TIMESTAMP(2),
+c3 TIMESTAMP(3),
+c4 TIMESTAMP(4),
+c5 TIMESTAMP(5),
+c6 TIMESTAMP(6)
+);
+CREATE TABLE t3
+(
+c0 DATETIME(0),
+c1 DATETIME(1),
+c2 DATETIME(2),
+c3 DATETIME(3),
+c4 DATETIME(4),
+c5 DATETIME(5),
+c6 DATETIME(6)
+);
+INSERT INTO t1 VALUES ('01:01:01','01:01:01.1','01:01:01.11','01:01:01.111','01:01:01.1111','01:01:01.11111','01:01:01.111111');
+INSERT INTO t2 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+INSERT INTO t3 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+t1	1	33	33
+t2	1	41	41
+t3	1	50	50
+SELECT * FROM t1;;
+c0	01:01:01
+c1	01:01:01.1
+c2	01:01:01.11
+c3	01:01:01.111
+c4	01:01:01.1111
+c5	01:01:01.11111
+c6	01:01:01.111111
+SELECT * FROM t2;;
+c0	2001-01-01 01:01:01
+c1	2001-01-01 01:01:01.1
+c2	2001-01-01 01:01:01.11
+c3	2001-01-01 01:01:01.111
+c4	2001-01-01 01:01:01.1111
+c5	2001-01-01 01:01:01.11111
+c6	2001-01-01 01:01:01.111111
+SELECT * FROM t3;;
+c0	2001-01-01 01:01:01
+c1	2001-01-01 01:01:01.1
+c2	2001-01-01 01:01:01.11
+c3	2001-01-01 01:01:01.111
+c4	2001-01-01 01:01:01.1111
+c5	2001-01-01 01:01:01.11111
+c6	2001-01-01 01:01:01.111111
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+t1	1	33	33
+t2	1	41	41
+t3	1	50	50
+DROP TABLE t1;
+DROP TABLE t2;
+DROP TABLE t3;
+SET @@global.mysql56_temporal_format=DEFAULT;
+SET @@global.mysql56_temporal_format=DEFAULT;
+include/rpl_end.inc

=== added file 'mysql-test/suite/rpl/r/rpl_temporal_format_mariadb53_to_mysql56.result'
--- mysql-test/suite/rpl/r/rpl_temporal_format_mariadb53_to_mysql56.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/r/rpl_temporal_format_mariadb53_to_mysql56.result	2014-08-29 09:36:32 +0000
@@ -0,0 +1,85 @@
+include/master-slave.inc
+[connection master]
+SET @@global.mysql56_temporal_format=false;;
+SET @@global.mysql56_temporal_format=true;;
+SELECT @@global.mysql56_temporal_format AS on_master;
+on_master
+0
+SELECT @@global.mysql56_temporal_format AS on_slave;
+on_slave
+1
+CREATE TABLE t1
+(
+c0 TIME(0),
+c1 TIME(1),
+c2 TIME(2),
+c3 TIME(3),
+c4 TIME(4),
+c5 TIME(5),
+c6 TIME(6)
+);
+CREATE TABLE t2
+(
+c0 TIMESTAMP(0),
+c1 TIMESTAMP(1),
+c2 TIMESTAMP(2),
+c3 TIMESTAMP(3),
+c4 TIMESTAMP(4),
+c5 TIMESTAMP(5),
+c6 TIMESTAMP(6)
+);
+CREATE TABLE t3
+(
+c0 DATETIME(0),
+c1 DATETIME(1),
+c2 DATETIME(2),
+c3 DATETIME(3),
+c4 DATETIME(4),
+c5 DATETIME(5),
+c6 DATETIME(6)
+);
+INSERT INTO t1 VALUES ('01:01:01','01:01:01.1','01:01:01.11','01:01:01.111','01:01:01.1111','01:01:01.11111','01:01:01.111111');
+INSERT INTO t2 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+INSERT INTO t3 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+t1	1	33	33
+t2	1	41	41
+t3	1	50	50
+SELECT * FROM t1;;
+c0	01:01:01
+c1	01:01:01.1
+c2	01:01:01.11
+c3	01:01:01.111
+c4	01:01:01.1111
+c5	01:01:01.11111
+c6	01:01:01.111111
+SELECT * FROM t2;;
+c0	2001-01-01 01:01:01
+c1	2001-01-01 01:01:01.1
+c2	2001-01-01 01:01:01.11
+c3	2001-01-01 01:01:01.111
+c4	2001-01-01 01:01:01.1111
+c5	2001-01-01 01:01:01.11111
+c6	2001-01-01 01:01:01.111111
+SELECT * FROM t3;;
+c0	2001-01-01 01:01:01
+c1	2001-01-01 01:01:01.1
+c2	2001-01-01 01:01:01.11
+c3	2001-01-01 01:01:01.111
+c4	2001-01-01 01:01:01.1111
+c5	2001-01-01 01:01:01.11111
+c6	2001-01-01 01:01:01.111111
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+t1	1	34	34
+t2	1	41	41
+t3	1	48	48
+DROP TABLE t1;
+DROP TABLE t2;
+DROP TABLE t3;
+SET @@global.mysql56_temporal_format=DEFAULT;
+SET @@global.mysql56_temporal_format=DEFAULT;
+include/rpl_end.inc

=== added file 'mysql-test/suite/rpl/r/rpl_temporal_format_mysql56_to_mariadb53.result'
--- mysql-test/suite/rpl/r/rpl_temporal_format_mysql56_to_mariadb53.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/r/rpl_temporal_format_mysql56_to_mariadb53.result	2014-08-29 09:29:49 +0000
@@ -0,0 +1,85 @@
+include/master-slave.inc
+[connection master]
+SET @@global.mysql56_temporal_format=true;;
+SET @@global.mysql56_temporal_format=false;;
+SELECT @@global.mysql56_temporal_format AS on_master;
+on_master
+1
+SELECT @@global.mysql56_temporal_format AS on_slave;
+on_slave
+0
+CREATE TABLE t1
+(
+c0 TIME(0),
+c1 TIME(1),
+c2 TIME(2),
+c3 TIME(3),
+c4 TIME(4),
+c5 TIME(5),
+c6 TIME(6)
+);
+CREATE TABLE t2
+(
+c0 TIMESTAMP(0),
+c1 TIMESTAMP(1),
+c2 TIMESTAMP(2),
+c3 TIMESTAMP(3),
+c4 TIMESTAMP(4),
+c5 TIMESTAMP(5),
+c6 TIMESTAMP(6)
+);
+CREATE TABLE t3
+(
+c0 DATETIME(0),
+c1 DATETIME(1),
+c2 DATETIME(2),
+c3 DATETIME(3),
+c4 DATETIME(4),
+c5 DATETIME(5),
+c6 DATETIME(6)
+);
+INSERT INTO t1 VALUES ('01:01:01','01:01:01.1','01:01:01.11','01:01:01.111','01:01:01.1111','01:01:01.11111','01:01:01.111111');
+INSERT INTO t2 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+INSERT INTO t3 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+t1	1	34	34
+t2	1	41	41
+t3	1	48	48
+SELECT * FROM t1;;
+c0	01:01:01
+c1	01:01:01.1
+c2	01:01:01.11
+c3	01:01:01.111
+c4	01:01:01.1111
+c5	01:01:01.11111
+c6	01:01:01.111111
+SELECT * FROM t2;;
+c0	2001-01-01 01:01:01
+c1	2001-01-01 01:01:01.1
+c2	2001-01-01 01:01:01.11
+c3	2001-01-01 01:01:01.111
+c4	2001-01-01 01:01:01.1111
+c5	2001-01-01 01:01:01.11111
+c6	2001-01-01 01:01:01.111111
+SELECT * FROM t3;;
+c0	2001-01-01 01:01:01
+c1	2001-01-01 01:01:01.1
+c2	2001-01-01 01:01:01.11
+c3	2001-01-01 01:01:01.111
+c4	2001-01-01 01:01:01.1111
+c5	2001-01-01 01:01:01.11111
+c6	2001-01-01 01:01:01.111111
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+t1	1	33	33
+t2	1	41	41
+t3	1	50	50
+DROP TABLE t1;
+DROP TABLE t2;
+DROP TABLE t3;
+SET @@global.mysql56_temporal_format=DEFAULT;
+SET @@global.mysql56_temporal_format=DEFAULT;
+include/rpl_end.inc

=== added file 'mysql-test/suite/rpl/r/rpl_temporal_format_mysql56_to_mysql56.result'
--- mysql-test/suite/rpl/r/rpl_temporal_format_mysql56_to_mysql56.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/r/rpl_temporal_format_mysql56_to_mysql56.result	2014-08-29 09:28:45 +0000
@@ -0,0 +1,85 @@
+include/master-slave.inc
+[connection master]
+SET @@global.mysql56_temporal_format=true;;
+SET @@global.mysql56_temporal_format=true;;
+SELECT @@global.mysql56_temporal_format AS on_master;
+on_master
+1
+SELECT @@global.mysql56_temporal_format AS on_slave;
+on_slave
+1
+CREATE TABLE t1
+(
+c0 TIME(0),
+c1 TIME(1),
+c2 TIME(2),
+c3 TIME(3),
+c4 TIME(4),
+c5 TIME(5),
+c6 TIME(6)
+);
+CREATE TABLE t2
+(
+c0 TIMESTAMP(0),
+c1 TIMESTAMP(1),
+c2 TIMESTAMP(2),
+c3 TIMESTAMP(3),
+c4 TIMESTAMP(4),
+c5 TIMESTAMP(5),
+c6 TIMESTAMP(6)
+);
+CREATE TABLE t3
+(
+c0 DATETIME(0),
+c1 DATETIME(1),
+c2 DATETIME(2),
+c3 DATETIME(3),
+c4 DATETIME(4),
+c5 DATETIME(5),
+c6 DATETIME(6)
+);
+INSERT INTO t1 VALUES ('01:01:01','01:01:01.1','01:01:01.11','01:01:01.111','01:01:01.1111','01:01:01.11111','01:01:01.111111');
+INSERT INTO t2 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+INSERT INTO t3 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+t1	1	34	34
+t2	1	41	41
+t3	1	48	48
+SELECT * FROM t1;;
+c0	01:01:01
+c1	01:01:01.1
+c2	01:01:01.11
+c3	01:01:01.111
+c4	01:01:01.1111
+c5	01:01:01.11111
+c6	01:01:01.111111
+SELECT * FROM t2;;
+c0	2001-01-01 01:01:01
+c1	2001-01-01 01:01:01.1
+c2	2001-01-01 01:01:01.11
+c3	2001-01-01 01:01:01.111
+c4	2001-01-01 01:01:01.1111
+c5	2001-01-01 01:01:01.11111
+c6	2001-01-01 01:01:01.111111
+SELECT * FROM t3;;
+c0	2001-01-01 01:01:01
+c1	2001-01-01 01:01:01.1
+c2	2001-01-01 01:01:01.11
+c3	2001-01-01 01:01:01.111
+c4	2001-01-01 01:01:01.1111
+c5	2001-01-01 01:01:01.11111
+c6	2001-01-01 01:01:01.111111
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+t1	1	34	34
+t2	1	41	41
+t3	1	48	48
+DROP TABLE t1;
+DROP TABLE t2;
+DROP TABLE t3;
+SET @@global.mysql56_temporal_format=DEFAULT;
+SET @@global.mysql56_temporal_format=DEFAULT;
+include/rpl_end.inc

=== modified file 'mysql-test/suite/rpl/r/rpl_temporal_mysql56_to_mariadb.result'
--- mysql-test/suite/rpl/r/rpl_temporal_mysql56_to_mariadb.result	2013-12-06 15:02:55 +0000
+++ mysql-test/suite/rpl/r/rpl_temporal_mysql56_to_mariadb.result	2014-08-29 08:54:24 +0000
@@ -20,17 +20,31 @@ mysql050614_temporal1	CREATE TABLE `mysq
   `b` datetime(1) DEFAULT NULL,
   `c` timestamp(1) NOT NULL DEFAULT CURRENT_TIMESTAMP(1) ON UPDATE CURRENT_TIMESTAMP(1)
 ) ENGINE=MyISAM DEFAULT CHARSET=latin1
+SELECT @@mysql56_temporal_format;
+@@mysql56_temporal_format
+1
 SET TIME_ZONE='+00:00';
 CREATE TABLE mysql050614_temporal0 (a time(0), b datetime(0), c timestamp(0)) engine=myisam;
 CREATE TABLE mysql050614_temporal1 (a time(1), b datetime(1), c timestamp(1)) engine=myisam;
 INSERT INTO mysql050614_temporal0 VALUES ('00:00:02','2001-01-01 00:00:02','2001-01-01 00:00:02');
 INSERT INTO mysql050614_temporal1 VALUES ('00:00:02.1','2001-01-01 00:00:02.2','2001-01-01 00:00:02.3');
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH, DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME LIKE 'mysql050614_temporal%' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+mysql050614_temporal0	2	13	26
+mysql050614_temporal1	1	16	16
 SELECT * FROM mysql050614_temporal0;
 a	b	c
 00:00:02	2001-01-01 00:00:02	2001-01-01 00:00:02
 SELECT * FROM mysql050614_temporal1;
 a	b	c
 00:00:02.1	2001-01-01 00:00:02.2	2001-01-01 00:00:02.3
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME LIKE 'mysql050614_temporal%' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+mysql050614_temporal0	1	13	13
+mysql050614_temporal1	1	16	16
+SET @@global.mysql56_temporal_format=DEFAULT;
 DROP TABLE mysql050614_temporal0;
 DROP TABLE mysql050614_temporal1;
 include/rpl_end.inc

=== added file 'mysql-test/suite/rpl/r/rpl_temporal_mysql56_to_mariadb53.result'
--- mysql-test/suite/rpl/r/rpl_temporal_mysql56_to_mariadb53.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/r/rpl_temporal_mysql56_to_mariadb53.result	2014-08-29 08:53:41 +0000
@@ -0,0 +1,51 @@
+include/master-slave.inc
+[connection master]
+SET @@global.mysql56_temporal_format=false;;
+#
+# Testing replication from MariaDB-10.0 master
+# started over MySQL-5.6 data directory
+# to MariaDB-10.0 slave running with natively created tables
+#
+SET TIME_ZONE='+00:00';
+SHOW CREATE TABLE mysql050614_temporal0;
+Table	Create Table
+mysql050614_temporal0	CREATE TABLE `mysql050614_temporal0` (
+  `a` time DEFAULT NULL,
+  `b` datetime DEFAULT NULL,
+  `c` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
+) ENGINE=MyISAM DEFAULT CHARSET=latin1
+SHOW CREATE TABLE mysql050614_temporal1;
+Table	Create Table
+mysql050614_temporal1	CREATE TABLE `mysql050614_temporal1` (
+  `a` time(1) DEFAULT NULL,
+  `b` datetime(1) DEFAULT NULL,
+  `c` timestamp(1) NOT NULL DEFAULT CURRENT_TIMESTAMP(1) ON UPDATE CURRENT_TIMESTAMP(1)
+) ENGINE=MyISAM DEFAULT CHARSET=latin1
+SELECT @@mysql56_temporal_format;
+@@mysql56_temporal_format
+0
+SET TIME_ZONE='+00:00';
+CREATE TABLE mysql050614_temporal0 (a time(0), b datetime(0), c timestamp(0)) engine=myisam;
+CREATE TABLE mysql050614_temporal1 (a time(1), b datetime(1), c timestamp(1)) engine=myisam;
+INSERT INTO mysql050614_temporal0 VALUES ('00:00:02','2001-01-01 00:00:02','2001-01-01 00:00:02');
+INSERT INTO mysql050614_temporal1 VALUES ('00:00:02.1','2001-01-01 00:00:02.2','2001-01-01 00:00:02.3');
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH, DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME LIKE 'mysql050614_temporal%' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+mysql050614_temporal0	2	13	26
+mysql050614_temporal1	1	16	16
+SELECT * FROM mysql050614_temporal0;
+a	b	c
+00:00:02	2001-01-01 00:00:02	2001-01-01 00:00:02
+SELECT * FROM mysql050614_temporal1;
+a	b	c
+00:00:02.1	2001-01-01 00:00:02.2	2001-01-01 00:00:02.3
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME LIKE 'mysql050614_temporal%' ORDER BY TABLE_NAME;
+TABLE_NAME	TABLE_ROWS	AVG_ROW_LENGTH	DATA_LENGTH
+mysql050614_temporal0	1	16	16
+mysql050614_temporal1	1	16	16
+SET @@global.mysql56_temporal_format=DEFAULT;
+DROP TABLE mysql050614_temporal0;
+DROP TABLE mysql050614_temporal1;
+include/rpl_end.inc

=== added file 'mysql-test/suite/rpl/t/rpl_temporal_format_default_to_default.test'
--- mysql-test/suite/rpl/t/rpl_temporal_format_default_to_default.test	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/t/rpl_temporal_format_default_to_default.test	2014-08-29 10:20:46 +0000
@@ -0,0 +1,76 @@
+--source include/master-slave.inc
+
+if ($force_master_mysql56_temporal_format)
+{
+  connection master;
+  eval SET @@global.mysql56_temporal_format=$force_master_mysql56_temporal_format;
+}
+
+if ($force_slave_mysql56_temporal_format)
+{
+  connection slave;
+  eval SET @@global.mysql56_temporal_format=$force_slave_mysql56_temporal_format;
+}
+
+connection master;
+SELECT @@global.mysql56_temporal_format AS on_master;
+connection slave;
+SELECT @@global.mysql56_temporal_format AS on_slave;
+connection master;
+
+CREATE TABLE t1
+(
+  c0 TIME(0),
+  c1 TIME(1),
+  c2 TIME(2),
+  c3 TIME(3),
+  c4 TIME(4),
+  c5 TIME(5),
+  c6 TIME(6)
+);
+CREATE TABLE t2
+(
+  c0 TIMESTAMP(0),
+  c1 TIMESTAMP(1),
+  c2 TIMESTAMP(2),
+  c3 TIMESTAMP(3),
+  c4 TIMESTAMP(4),
+  c5 TIMESTAMP(5),
+  c6 TIMESTAMP(6)
+);
+
+CREATE TABLE t3
+(
+  c0 DATETIME(0),
+  c1 DATETIME(1),
+  c2 DATETIME(2),
+  c3 DATETIME(3),
+  c4 DATETIME(4),
+  c5 DATETIME(5),
+  c6 DATETIME(6)
+);
+INSERT INTO t1 VALUES ('01:01:01','01:01:01.1','01:01:01.11','01:01:01.111','01:01:01.1111','01:01:01.11111','01:01:01.111111');
+INSERT INTO t2 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+INSERT INTO t3 VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+sync_slave_with_master;
+
+connection slave;
+--query_vertical SELECT * FROM t1;
+--query_vertical SELECT * FROM t2;
+--query_vertical SELECT * FROM t3;
+SELECT TABLE_NAME, TABLE_ROWS, AVG_ROW_LENGTH,DATA_LENGTH FROM INFORMATION_SCHEMA.TABLES
+WHERE TABLE_NAME RLIKE 't[1-3]' ORDER BY TABLE_NAME;
+
+connection master;
+DROP TABLE t1;
+DROP TABLE t2;
+DROP TABLE t3;
+
+connection slave;
+SET @@global.mysql56_temporal_format=DEFAULT;
+connection master;
+SET @@global.mysql56_temporal_format=DEFAULT;
+
+--source include/rpl_end.inc

=== added file 'mysql-test/suite/rpl/t/rpl_temporal_format_mariadb53_to_mariadb53.test'
--- mysql-test/suite/rpl/t/rpl_temporal_format_mariadb53_to_mariadb53.test	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/t/rpl_temporal_format_mariadb53_to_mariadb53.test	2014-08-29 10:10:47 +0000
@@ -0,0 +1,4 @@
+--let $force_master_mysql56_temporal_format=false;
+--let $force_slave_mysql56_temporal_format=false;
+
+--source rpl_temporal_format_default_to_default.test

=== added file 'mysql-test/suite/rpl/t/rpl_temporal_format_mariadb53_to_mysql56.test'
--- mysql-test/suite/rpl/t/rpl_temporal_format_mariadb53_to_mysql56.test	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/t/rpl_temporal_format_mariadb53_to_mysql56.test	2014-08-29 10:31:41 +0000
@@ -0,0 +1,14 @@
+#
+# MariaDB-5.3 fractional temporal types do not store metadata 
+# when running with --binlog-format=row, thus can replicate
+# only into a field with exactly the same data type and format.
+#
+# Skip when running with --binlog-format=row.
+# But mixed and statement formats should work without problems.
+#
+-- source include/have_binlog_format_mixed_or_statement.inc
+
+--let $force_master_mysql56_temporal_format=false;
+--let $force_slave_mysql56_temporal_format=true;
+
+--source rpl_temporal_format_default_to_default.test

=== added file 'mysql-test/suite/rpl/t/rpl_temporal_format_mysql56_to_mariadb53.test'
--- mysql-test/suite/rpl/t/rpl_temporal_format_mysql56_to_mariadb53.test	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/t/rpl_temporal_format_mysql56_to_mariadb53.test	2014-08-29 10:10:58 +0000
@@ -0,0 +1,4 @@
+--let $force_master_mysql56_temporal_format=true;
+--let $force_slave_mysql56_temporal_format=false;
+
+--source rpl_temporal_format_default_to_default.test

=== added file 'mysql-test/suite/rpl/t/rpl_temporal_format_mysql56_to_mysql56.test'
--- mysql-test/suite/rpl/t/rpl_temporal_format_mysql56_to_mysql56.test	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/t/rpl_temporal_format_mysql56_to_mysql56.test	2014-08-29 10:11:05 +0000
@@ -0,0 +1,4 @@
+--let $force_master_mysql56_temporal_format=true;
+--let $force_slave_mysql56_temporal_format=true;
+
+--source rpl_temporal_format_default_to_default.test

